#!/usr/bin/python

# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


from mercurial import hg
from datetime import datetime, timedelta
from vcpx.tzinfo import FixedOffset
import operator as op
from itertools import *

normalize={
	'mail@joachim-breitner.de' : 'Joachim Breitner <mail@joachim-breitner.de>',
	'Mathias Ziebarth <untix@gmx.net>': 'Mathias Ziebarth <mathiasziebarth@gmx.de>',
}


repo = hg.repository(ui=None, path="file://.")

all_commits = {}

for i in xrange(repo.changelog.count()):
	n = repo.changelog.node(i)
	manifest, user, date, files, message, _= repo.changelog.read(n)

        dt, tz = date
	date = datetime.fromtimestamp(dt, FixedOffset(-tz/60))
	all_commits.setdefault(normalize.get(user, user), []).append(date)

total = timedelta(0)
n = 0

for user, commits in all_commits.iteritems():
	commits.sort()
	deltas = map(op.sub, commits[1:], commits[:-1])
	def isShort(d): return d < timedelta(0,60*60*2)
	shortD = filter(isShort, deltas)
	if not shortD:
		continue
	avg = reduce(op.add,shortD) // len(shortD)
	tot = avg * len(commits)
	total += tot
	n += len(commits)
	print avg, len(commits), tot, user

print total//n, n, total
